#ifdef WIN32
	#include <windows.h>
	#pragma comment(lib, "Irrlicht.lib")

	//SDLpݒ
	#pragma comment(lib, "SDL.lib")
	#pragma comment(lib, "SDLmain.lib")
	//C/C++R[h^CCu}`XbhDLLɕύX
	//Kvł΁A郉CuɁumsvcrt.libvݒ
#endif

#include <SDL/SDL.h> 
#include <SDL/SDL_syswm.h>//SysWMinfogp

#include <irrlicht.h>
#include "draw.h"

using namespace irr;
using namespace core;
using namespace video;
using namespace scene;

typedef struct
{
	int x,y;
}POS;

POS pos;

//WCXeBbN
SDL_Joystick* joystick_init(u32 num)
{
	//p\ȃWCXeBbN
	u32 cnt = SDL_NumJoysticks();

	if(cnt == 0 || cnt < num)
		return 0;

	//WCXeBbÑI[v
	SDL_Joystick *joystick;

	SDL_JoystickEventState(SDL_ENABLE);
	joystick = SDL_JoystickOpen(num);

	//WCXeBbN擾
	//const char* name = SDL_JoystickName(num);

	return joystick;
}

//WCXeBbNI
void joystick_close(SDL_Joystick *joystick)
{
	if(joystick != NULL)
		SDL_JoystickClose(joystick);
}


//L[Cxg
int keyFunc(IrrlichtDevice *device) 
{ 
	SDL_Event event;
	//if(SDL_WaitEvent(&event))//҂
	//if(SDL_PollEvent(&event))
	while(SDL_PollEvent(&event))
	{
		switch(event.type)
		{
			case SDL_QUIT:
				device->closeDevice();
				break;
			//L[{[h
			case SDL_KEYDOWN:
			{
				switch(event.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						device->closeDevice();
						break;
					case SDLK_w:
						pos.y--;
						break;
					case SDLK_a:
						pos.x--;
						break;
					case SDLK_s:
						pos.y++;
						break;
					case SDLK_d:
						pos.x++;
						break;
				}
			}
			//XeBbN(̏\L[)
			case SDL_JOYAXISMOTION:
				//E̓
				if(event.jaxis.axis == 0) 
				{
					if(event.jaxis.value < -0x7000)
						pos.x--;
					if(event.jaxis.value >  0x7000)
						pos.x++;
				}

				//㉺̓
				if(event.jaxis.axis == 1) 
				{
					if(event.jaxis.value < -0x7000)
						pos.y--;
					if(event.jaxis.value >  0x7000)
						pos.y++;
				}
				break;
			//̏\L[(ANALOG[hł擾\)
			case SDL_JOYHATMOTION:
				switch(event.jhat.value)
				{
					case SDL_HAT_UP:
						pos.y--;
						break;
					case SDL_HAT_LEFT:
						pos.x--;
						break;
					case SDL_HAT_DOWN:
						pos.y++;
						break;
					case SDL_HAT_RIGHT:
						pos.x++;
						break;
				}
				break;
			//{^
			case SDL_JOYBUTTONDOWN:
				switch(event.jbutton.button)
				{
					case 0://
						break;
					case 1://
						break;
					case 2://~
						break;
					case 3://
						break;
					case 4://L2
						break;
					case 5://R2
						break;
					case 6://L1
						break;
					case 7://R1
						break;
					case 8://START
						break;
					case 9://SELECT
						break;
					case 10://L3
						break;
					case 11://R3
						break;
				}
				break;
		}
	}

	return 0;
}

//SDLpfoCX쐬
IrrlichtDevice* createDeviceSDL
(
	video::E_DRIVER_TYPE deviceType,
	const core::dimension2d<s32> & windowSize,
	u32 bits,
	bool fullscreen,
	bool stencilbuffer,
	bool vsync,
	IEventReceiver* receiver,
	const c8* sdk_version_do_not_use)
{
	//SDLtO(ɂďĂ)
	u32 flags = SDL_HWSURFACE|SDL_DOUBLEBUF;
	if(fullscreen)
		flags |= SDL_FULLSCREEN;

	//SDL̏
	if(SDL_Init(SDL_INIT_EVERYTHING) < 0)
		return 0;

	//vOǏĂяo֐w
	atexit(SDL_Quit);

	//SDLrfI\̏
//	if(SDL_SetVideoMode(windowSize.Width, windowSize.Height, bits, flags) == 0)
//		return 0;

	//L[s[gL(50ms)
	SDL_EnableKeyRepeat(50,50);

	//L[UnicodeϊL
	SDL_EnableUNICODE(1);

	//SDLVXe擾(WindoIDp)
	SDL_SysWMinfo wmInfo;			//VXe擾p\
	SDL_VERSION(&wmInfo.version);	//VXever擾
	SDL_GetWMInfo(&wmInfo);			//verEChE擾

	//p[^쐬
	SIrrlichtCreationParameters param;
	param.AntiAlias     = false;
	param.Bits          = bits;
	param.DriverType    = deviceType;//EDT_OPENGL;
	param.Fullscreen    = fullscreen;
	param.Stencilbuffer = stencilbuffer;
	param.Vsync         = vsync;
	param.WindowSize    = windowSize;
	param.WindowId      = NULL;//wmInfo.window;//SDL̃EChEnhw

	IrrlichtDevice *device = createDeviceEx(param);

	//V[oݒ
	device->setEventReceiver(receiver);

	return device;
}

//V[쐬
void makeScene(IVideoDriver *driver)
{
	DrawImage(driver,"data/icon.bmp",4,120,32,32,64,0,true,0x80FFFFFF,0,0,0,2,2);
	DrawLine(driver,   10, 10,310,10,0xFFFF0000,2);
	DrawLine(driver,  310, 10,310,180,0xFFFF0000,5);
	DrawLine(driver,   10, 10,310,180,0xFFFF0000);
	DrawRect(driver,   10,100, 50, 50,0xFFFFFF00);
	FillRect(driver,   20, 20,100,100,0xA00000FF, PS_SOLID);
	FillRect2(driver, 200, 20,100,100,0xFFFF0000, 
		0xFF00FF00, 0xFF0000FF, 0xFFFFFF00, PS_SOLID);
	FillRect2(driver, 110,100,100,100,0xFFFFFFFF, 
		0xFF000000, 0xFF00FFFF, 0xFFFF00FF, PS_USERSTYLE);
	DrawOval(driver,  160, 80, 50,0xFFFFFFFF,30);
	FillOval(driver,  250,120, 50,0x90FF0000,30);

	FillRect(driver,  0,200,40,40,0xFF000000,PS_SOLID);
	FillRect(driver, 40,200,40,40,0xFF222222,PS_DASH);
	FillRect(driver, 80,200,40,40,0xFF444444,PS_DOT);
	FillRect(driver,120,200,40,40,0xFF666666,PS_DASHDOT);
	FillRect(driver,160,200,40,40,0xFF888888,PS_DASHDOTDOT);
	FillRect(driver,200,200,40,40,0xFFAAAAAA,PS_NULL);
	FillRect(driver,240,200,40,40,0xFFCCCCCC,PS_INSIDEFRAME);
	FillRect(driver,280,200,40,40,0xFFEEEEEE,PS_USERSTYLE);

	Printf(driver,50,50,NULL,0xFFFFFFFF,"̫ޕ\eXg (%d:%d)", pos.x, pos.y);
}

//#ifdef WIN32
//	int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR strCmdLine, int nShowCmd)
//#else
//	int main()
//#endif

//SDLpC֐iWindows̏ꍇAmain}NSDL_mainɒu܂j
//uSDL_mainȂvƂG[oꍇ́Aȉ̂悤ɏĂ
int SDL_main(int argc, char* argv[])
{
	IrrlichtDevice *device = createDeviceSDL(EDT_OPENGL,dimension2d<s32>(320,240),16,false,false,false,0,0);

	device->setWindowCaption(L"Irrlicht");//EChE^Cgݒ

	IVideoDriver* driver = device->getVideoDriver();
	ISceneManager* smgr  = device->getSceneManager();

	SDL_Joystick* joystick0 = joystick_init(0);

	DrawInit(device, driver);

	while(device->run())
	{
		driver->beginScene(true, true, 0xFF6060FF);

		//L[
		keyFunc(device);

		//}`쐬
		makeScene(driver);

		//V[̕`
		smgr->drawAll();

		driver->endScene();
	}

	device->drop();

	joystick_close(joystick0);

	return 0;
}
